All of lore.kernel.org
 help / color / mirror / Atom feed
From: Chandan Babu R <chandanrlinux@gmail.com>
To: fstests@vger.kernel.org
Cc: Chandan Babu R <chandanrlinux@gmail.com>,
	linux-xfs@vger.kernel.org, darrick.wong@oracle.com
Subject: [PATCH 11/11] xfs: Stress test with with bmap_alloc_minlen_extent error tag enabled
Date: Fri, 13 Nov 2020 16:57:03 +0530	[thread overview]
Message-ID: <20201113112704.28798-12-chandanrlinux@gmail.com> (raw)
In-Reply-To: <20201113112704.28798-1-chandanrlinux@gmail.com>

This commit adds a stress test that executes fsstress with
bmap_alloc_minlen_extent error tag enabled.

Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com>
---
 tests/xfs/531     | 85 +++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/531.out |  6 ++++
 tests/xfs/group   |  1 +
 3 files changed, 92 insertions(+)
 create mode 100755 tests/xfs/531
 create mode 100644 tests/xfs/531.out

diff --git a/tests/xfs/531 b/tests/xfs/531
new file mode 100755
index 00000000..e846cc0e
--- /dev/null
+++ b/tests/xfs/531
@@ -0,0 +1,85 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Chandan Babu R.  All Rights Reserved.
+#
+# FS QA Test 531
+#
+# Execute fsstress with bmap_alloc_minlen_extent error tag enabled.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/inject
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs xfs
+_require_scratch
+_require_xfs_debug
+_require_test_program "punch-alternating"
+_require_xfs_io_error_injection "bmap_alloc_minlen_extent"
+
+echo "Format and mount fs"
+_scratch_mkfs_sized $((1024 * 1024 * 1024)) >> $seqres.full
+_scratch_mount >> $seqres.full
+
+bsize=$(_get_block_size $SCRATCH_MNT)
+
+testfile=$SCRATCH_MNT/testfile
+
+echo "Consume free space"
+dd if=/dev/zero of=${testfile} bs=${bsize} >> $seqres.full 2>&1
+sync
+
+echo "Create fragmented filesystem"
+$here/src/punch-alternating $testfile >> $seqres.full
+sync
+
+echo "Inject bmap_alloc_minlen_extent error tag"
+xfs_io -x -c 'inject bmap_alloc_minlen_extent' $SCRATCH_MNT
+
+echo "Execute fsstress in background"
+$FSSTRESS_PROG -d $SCRATCH_MNT -p128 -n999999999 \
+		 -f bulkstat=0 \
+		 -f bulkstat1=0 \
+		 -f fiemap=0 \
+		 -f getattr=0 \
+		 -f getdents=0 \
+		 -f getfattr=0 \
+		 -f listfattr=0 \
+		 -f mread=0 \
+		 -f read=0 \
+		 -f readlink=0 \
+		 -f readv=0 \
+		 -f stat=0 \
+		 -f aread=0 \
+		 -f dread=0 > /dev/null 2>&1 &
+
+fsstress_pid=$!
+sleep 2m
+
+echo "Killing fsstress process $fsstress_pid ..." >> $seqres.full
+kill $fsstress_pid >> $seqres.full
+wait $fsstress_pid
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/531.out b/tests/xfs/531.out
new file mode 100644
index 00000000..e0a419c2
--- /dev/null
+++ b/tests/xfs/531.out
@@ -0,0 +1,6 @@
+QA output created by 531
+Format and mount fs
+Consume free space
+Create fragmented filesystem
+Inject bmap_alloc_minlen_extent error tag
+Execute fsstress in background
diff --git a/tests/xfs/group b/tests/xfs/group
index 81a15582..f4cb5af6 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -528,3 +528,4 @@
 528 auto quick reflink
 529 auto quick reflink
 530 auto quick
+531 auto stress
-- 
2.28.0


  parent reply	other threads:[~2020-11-13 12:05 UTC|newest]

Thread overview: 36+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-11-13 11:26 [PATCH 00/11] xfs: Tests to check for inode fork extent count overflow detection Chandan Babu R
2020-11-13 11:26 ` [PATCH 01/11] common/xfs: Add a helper to get an inode fork's extent count Chandan Babu R
2020-11-14  0:10   ` Darrick J. Wong
2020-11-13 11:26 ` [PATCH 02/11] xfs: Check for extent overflow when trivally adding a new extent Chandan Babu R
2020-11-14  0:24   ` Darrick J. Wong
2020-11-17 14:12     ` Chandan Babu R
2020-11-18  2:30       ` Darrick J. Wong
2020-11-18  4:09         ` Chandan Babu R
2020-11-13 11:26 ` [PATCH 03/11] " Chandan Babu R
2020-11-14  0:18   ` Darrick J. Wong
2020-11-17 14:22     ` Chandan Babu R
2020-11-13 11:26 ` [PATCH 04/11] xfs: Check for extent overflow when punching a hole Chandan Babu R
2020-11-14  0:28   ` Darrick J. Wong
2020-11-17 14:26     ` Chandan Babu R
2020-11-13 11:26 ` [PATCH 05/11] xfs: Check for extent overflow when adding/removing xattrs Chandan Babu R
2020-11-14  0:34   ` Darrick J. Wong
2020-11-17 14:30     ` Chandan Babu R
2020-11-13 11:26 ` [PATCH 06/11] xfs: Check for extent overflow when adding/removing dir entries Chandan Babu R
2020-11-14  0:37   ` Darrick J. Wong
2020-11-17 14:50     ` Chandan Babu R
2020-11-13 11:26 ` [PATCH 07/11] xfs: Check for extent overflow when writing to unwritten extent Chandan Babu R
2020-11-14  0:39   ` Darrick J. Wong
2020-11-17 15:15     ` Chandan Babu R
2020-11-13 11:27 ` [PATCH 08/11] xfs: Check for extent overflow when moving extent from cow to data fork Chandan Babu R
2020-11-14  0:42   ` Darrick J. Wong
2020-11-18  5:20     ` Chandan Babu R
2020-11-13 11:27 ` [PATCH 09/11] xfs: Check for extent overflow when remapping an extent Chandan Babu R
2020-11-14  0:43   ` Darrick J. Wong
2020-11-13 11:27 ` [PATCH 10/11] xfs: Check for extent overflow when swapping extents Chandan Babu R
2020-11-14  0:08   ` Darrick J. Wong
2020-11-17 15:35     ` Chandan Babu R
2020-11-18  2:23       ` Darrick J. Wong
2020-11-13 11:27 ` Chandan Babu R [this message]
2020-11-14  0:06   ` [PATCH 11/11] xfs: Stress test with with bmap_alloc_minlen_extent error tag enabled Darrick J. Wong
2020-11-17 15:24     ` Chandan Babu R
2020-11-13 11:29 ` [PATCH 00/11] xfs: Tests to check for inode fork extent count overflow detection Chandan Babu R

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20201113112704.28798-12-chandanrlinux@gmail.com \
    --to=chandanrlinux@gmail.com \
    --cc=darrick.wong@oracle.com \
    --cc=fstests@vger.kernel.org \
    --cc=linux-xfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.